%define vendor qlgc 
%define driver_name qla4xxx
%define driver_version 5.01.03.03.10.3-d5
%define version %( echo "%{driver_version}" | tr '-' '_' )
%define dist sles
%define distver 10
%define release 1

%define  BUILD_KERNEL_SPEC %( if [ -z "${BUILD_KERNEL}" ]; then BUILD_KERNEL=`uname -r`; fi; echo "${BUILD_KERNEL}" | cut -d "-" -f -2 )

Summary:      Linux driver for the QLogic iSCSI adapter 
Name:         %{vendor}-%{driver_name}
BuildRequires: kernel-source kernel-syms
License:      GPL
Group:        System/Kernel
Version:      %{version}
Release:      %{release}
Vendor:       QLogic Corp.
Packager:     Vikas Chaudhary <vikas.chaudhary@qlogic.com>
Source0:      %{driver_name}-src-v%{driver_version}.tar.gz
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%suse_kernel_module_package kdump um 

%description
This package contains QLogic %{driver_name} iSCSI driver

%package KMP
Summary: Update for Qlogic qla4xxx driver
Group: System/Kernel

%description KMP
This package contains a driver update for QLogic qla4xxx driver  

%prep
%setup -n %{driver_name}-%{driver_version}
set -- *
mkdir source
mv "$@" source/
mkdir obj
cd source

%build
export EXTRA_CFLAGS='-DVERSION=\"%version\"'
for flavor in %flavors_to_build; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
	%{__make} -C /usr/src/linux-%{BUILD_KERNEL_SPEC}-obj/%_target_cpu/$flavor modules M=$PWD/obj/$flavor
done

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
	%{__make} -C /usr/src/linux-%{BUILD_KERNEL_SPEC}-obj/%_target_cpu/$flavor modules_install M=$PWD/obj/$flavor
done

%changelog
* Wed Oct 28 2009 - vikas.chaudhary@qlogic.com
- Initial package 
