/*
 * QLogic iSCSI HBA Driver
 * Copyright (c)  2003-2012 QLogic Corporation
 *
 * See LICENSE.qla4xxx for copyright and licensing details.
 */

/*
 * Driver Versioning Scheme:
 * Major.Minor.Patch.Subminor.Distro.DistroLevel-SuffixBeta
 *
 * - Major#: Denotes driver family
 *           (i.e. 5=iSCSI 2.6, 3=iSCSI 2.4, etc.)
 * - Minor#: Denotes which iSCSI chip is supported
 *           (i.e. 5.01=Add 4032, 5.02=Add P3P, etc.)
 * - Patch#: Major Feature or structure (common w/ IOCTL) change.
 *           Must match patch# in corresponding qisioctl.
 *           **************************************************
 *           ***   Also used to distinguish inbox vs OOT    ***
 *           ***   (Inbox = even number, OOT = odd number)  ***
 *           **************************************************
 * - Subminor#: Updated per external release if the above numbers remain
 *           unchanged. Set to 0 if above numbers are changed.
 * - Beta#:  To be used for internal/test/EVT builds.
 *           Set to 0 for release to DVT or external users.
 * - Suffix [-k/-c/-d]:
 *           -k: upstream or sysfs based drivers,
 *           -d: ioctl based,
 *           -c: Citrix XenServer based
 */

#define QLA4XXX_DRIVER_VERSION      "5.03.01.05.10.4-d0"

#define QL4_DRIVER_MAJOR_VER	5
#define QL4_DRIVER_MINOR_VER	3
#define QL4_DRIVER_PATCH_VER	1
#define QL4_DRIVER_BETA_VER	0
