/*
 * QLogic iSCSI IOCTL Module
 * Copyright (c)  2003-2012 QLogic Corporation
 *
 * See LICENSE.qla4xxx for copyright and licensing details.
 */

/******************************************************************************
 *             Please see release.txt for revision history.                   *
 *                                                                            *
 ******************************************************************************
 * Function Table of Contents:
 *
 ****************************************************************************/


/*
 *  Debug Print Routine Prototypes.
 */
#define ENTER(x) do {DEBUG12(printk("qisioctl: Entering %s()\n", x));} while(0);
#define LEAVE(x) do {DEBUG12(printk("qisioctl: Leaving  %s()\n", x));} while(0);

void     ql4im_dump_bytes(void *, uint32_t);
void     ql4im_dump_words(void *, uint32_t);
void     ql4im_dump_dwords(void *, uint32_t);
void     ql4im_dump_registers(scsi_qla_host_t *ha);
void     ql4im_print_iocb_passthru(scsi_qla_host_t *ha, INT_IOCB_PASSTHRU *iocb);

/*
 * Driver debug definitions.
 */
/* #define QL_DEBUG_LEVEL_1  */	/* Output register accesses to COM1 */

/* #define QL_DEBUG_LEVEL_3  */	/* Output function trace msgs to COM1 */
/* #define QL_DEBUG_LEVEL_4  */
/* #define QL_DEBUG_LEVEL_5  */	
/* #define QL_DEBUG_LEVEL_7  */	
/* #define QL_DEBUG_LEVEL_9  */	
/* #define QL_DEBUG_LEVEL_10 */
/* #define QL_DEBUG_LEVEL_12 */

/* #define QL_DEBUG_LEVEL_2  */ /* Output error msgs to COM1 */

#define DEBUG(x)	do {} while (0);

#if defined(QL_DEBUG_LEVEL_2)
#define DEBUG2(x)      do {x;} while (0);
#define DEBUG2_3(x)   do {x;} while (0);
#else
#define DEBUG2(x)	do {} while (0);
#endif

#if defined(QL_DEBUG_LEVEL_3)
#define DEBUG3(x)	do {x;} while (0);
#else
#define DEBUG3(x)	do {} while (0);
  #if !defined(QL_DEBUG_LEVEL_2)
  #define DEBUG2_3(x)	do {} while (0);
  #endif
#endif
#if defined(QL_DEBUG_LEVEL_4)
#define DEBUG4(x)	do {x;} while (0);
#else
#define DEBUG4(x)	do {} while (0);
#endif

#if defined(QL_DEBUG_LEVEL_5)
#define DEBUG5(x)	do {x;} while (0);
#else
#define DEBUG5(x)	do {} while (0);
#endif

#if defined(QL_DEBUG_LEVEL_7)
#define DEBUG7(x)	do {x;} while (0);
#else
#define DEBUG7(x)	do {} while (0);
#endif

#if defined(QL_DEBUG_LEVEL_9)
#define DEBUG9(x)	do {x;} while (0);
#else
#define DEBUG9(x)	do {} while (0);
#endif

#if defined(QL_DEBUG_LEVEL_10)
#define DEBUG10(x)	do {x;} while (0);
#else
#define DEBUG10(x)	do {} while (0);
#endif

#if defined(QL_DEBUG_LEVEL_12)
#define DEBUG12(x)	do {x;} while (0);
#else
#define DEBUG12(x)	do {} while (0);
#endif

/*
 * Overrides for Emacs so that we almost follow Linus's tabbing style.
 * Emacs will notice this stuff at the end of the file and automatically
 * adjust the settings for this buffer only.  This must remain at the end
 * of the file.
 * ---------------------------------------------------------------------------
 * Local variables:
 * c-indent-level: 2
 * c-brace-imaginary-offset: 0
 * c-brace-offset: -2
 * c-argdecl-indent: 2
 * c-label-offset: -2
 * c-continued-statement-offset: 2
 * c-continued-brace-offset: 0
 * indent-tabs-mode: nil
 * tab-width: 8
 * End:
 */

