/*
 * QLogic iSCSI IOCTL Module
 * Copyright (c)  2003-2012 QLogic Corporation
 *
 * See LICENSE.qla4xxx for copyright and licensing details.
 */

/******************************************************************************
 * Global include file.
 ****************************************************************************/
#ifndef __QL4IM_GBL_H
#define	__QL4IM_GBL_H

/*
 * Defined in ql4_os.c
 */
extern srb_t *del_from_active_array(scsi_qla_host_t *ha, uint32_t index);
extern ql4im_scsi_qla_host_t *ql4im_get_adapter_handle(uint16_t instance);
extern uint16_t ql4im_get_hba_count(void);
extern int ql4im_down_timeout(struct semaphore *sema, unsigned long timeout);


/*
 * Defined in  ql4_mbx.c
 */
extern uint8_t ql4im_mailbox_command(scsi_qla_host_t *ha, uint8_t inCount, uint8_t outCount, uint32_t *mbx_cmd, uint32_t *mbx_sts);
#if ISNS_SUPPORTED
extern uint8_t ql4im_mbx_isns_enable(scsi_qla_host_t *, uint32_t, uint16_t);
extern uint8_t ql4im_mbx_isns_disable(scsi_qla_host_t *);
#endif
extern uint8_t ql4im_mbx_restore_factory_defaults(scsi_qla_host_t *ha,
						  uint32_t block_mask,
						  uint32_t ifcb_mask1,
						  uint32_t ifcb_mask2);
extern uint8_t ql4im_mbx_get_fwddb_entry(scsi_qla_host_t *ha,
		      uint16_t        fw_ddb_index,
		      DEV_DB_ENTRY    *fw_ddb_entry,
		      dma_addr_t      fw_ddb_entry_dma,
		      uint32_t        *num_valid_ddb_entries,
		      uint32_t        *next_ddb_index,
		      uint32_t        *fw_ddb_device_state,
		      uint32_t        *conn_err_detail,
		      uint16_t        *tcp_source_port_num,
		      uint16_t        *connection_id);
extern uint8_t ql4im_mbx_set_ddb_entry(scsi_qla_host_t *ha,
		      uint16_t        fw_ddb_index,
		      DEV_DB_ENTRY    *fw_ddb_entry,
		      dma_addr_t      fw_ddb_entry_dma);
extern uint8_t ql4im_mbx_get_flash(scsi_qla_host_t *, dma_addr_t, uint32_t, uint32_t);
extern uint8_t ql4im_mbx_conn_close_sess_logout(scsi_qla_host_t *ha, uint16_t fw_ddb_index,
			       uint16_t connection_id, uint16_t option);
extern uint8_t ql4im_mbx_clear_database_entry(scsi_qla_host_t *ha, uint16_t fw_ddb_index);

/*
 * Defined in  ql4_inioct.c
 */
extern void ql4im_iocb_pass_done(ql4im_scsi_qla_host_t *ql4im_ha, PASSTHRU_STATUS_ENTRY *sts_entry);
extern uint8_t ql4im_capture_dump_image(ql4im_scsi_qla_host_t *ql4im_ha, void *dump_image, uint32_t size);
extern void ql4im_build_dump_image_header(ql4im_scsi_qla_host_t *ql4im_ha, void *dump_image_header);
extern void qla4intioctl_update_beacon(ql4im_scsi_qla_host_t *ql4im_ha,
				EXT_IOCTL_ISCSI *ioctl, uint32_t *mbox_cmd,
				uint32_t *mbox_sts);

/*
 * Defined in  ql4_xioct.c
 */
extern void ql4im_scsi_pass_done(struct scsi_cmnd *cmd);
extern void ql4im_ioctl_sem_init(ql4im_scsi_qla_host_t *ql4im_ha);
extern int qla4xxx_ioctl_exit(void);
extern int qla4xxx_ioctl_init(void);

/*
 * Defined in  ql4im_iocb.c
 */
extern uint8_t ql4im_get_req_pkt(scsi_qla_host_t *ha, QUEUE_ENTRY **queue_entry);


/*
 * Defined in  ql4im_sup.c
 */
extern ddb_entry_t *ql4im_lookup_ddb_by_fw_index(scsi_qla_host_t *ha, uint32_t fw_ddb_index);
extern os_tgt_t *ql4im_lookup_target_by_fcport(scsi_qla_host_t *ha, fc_port_t  *fcport);
extern os_tgt_t *ql4im_lookup_target_by_SCSIID(scsi_qla_host_t *ha, uint32_t bus, uint32_t target);
extern os_lun_t *ql4im_lookup_lun_handle(scsi_qla_host_t *ha, os_tgt_t *tq, uint16_t lun);
extern srb_t *ql4im_del_from_free_srb_q_head(scsi_qla_host_t *ha);
extern void ql4im_add_to_free_srb_q(scsi_qla_host_t *ha, srb_t *srb);
extern void ql4im_isns_build_entity_id(scsi_qla_host_t *ha);
extern void ql4im_flush_all_srbs(scsi_qla_host_t *ha, ddb_entry_t *ddb_entry, os_lun_t *lun_entry);
extern void ql4im_add_timer_to_cmd(srb_t *srb, int timeout);
extern void ql4im_delete_timer_from_cmd(srb_t *srb);
void ql4im_request_cleanup(scsi_qla_host_t *ha, srb_t *srb);
#if ISNS_SUPPORTED
extern uint8_t ql4im_isns_reenable(scsi_qla_host_t *, uint32_t, uint16_t);
#endif
extern uint8_t ql4im_logout_device(scsi_qla_host_t *ha, uint16_t fw_ddb_index, uint16_t connection_id);
extern uint8_t ql4im_login_device(scsi_qla_host_t *ha, uint16_t fw_ddb_index, uint16_t connection_id);
extern uint8_t ql4im_delete_device(scsi_qla_host_t *ha, uint16_t fw_ddb_index, uint16_t connection_id);
extern uint8_t ql4im_reindex_ddb(scsi_qla_host_t *ha, uint32_t old_fw_ddb_index, uint32_t new_fw_ddb_index);
extern uint8_t ql4im_send_command_to_isp(scsi_qla_host_t *os_ha, srb_t *srb);
extern uint8_t ql4im_wait_for_hba_online(scsi_qla_host_t *ha);
extern void ql4im_update_local_ifcb(scsi_qla_host_t *ha, ADDRESS_CTRL_BLK  *init_fw_cb);


#if defined(CONFIG_COMPAT) && !defined(CONFIG_IA64)
/*
 * Defined in  ql4_32ioctl.c
 */
extern void ql4_apidev_init_32ioctl(void);
extern void ql4_apidev_cleanup_32ioctl(void);
#endif

#endif /* _QL4IM_GBL_H */
