/*
 * QLogic iSCSI IOCTL Module
 * Copyright (c)  2003-2012 QLogic Corporation
 *
 * See LICENSE.qla4xxx for copyright and licensing details.
 */

#ifndef _QL4_IOCTL_H_
#define _QL4_IOCTL_H_

#include <linux/blkdev.h>
#include <asm/uaccess.h>
#include "ql4im_dump.h"

/*---------------------------------------------------------------------------*/

#define QLA_IOCTL_SCRAP_SIZE           17000 /* scrap memory for local use. */
#define QLA_IOCTL_DUMP_IMAGE_SIZE      DUMP_IMAGE_SIZE + (0x4000 - (DUMP_IMAGE_SIZE % 0x4000)) /* scrap memory for local use. */

typedef struct {
	int cmd;
	char *s;
} ioctl_tbl_row_t;

#define	QL_KMEM_ZALLOC(siz)	ql4_kzmalloc((siz), GFP_ATOMIC)
#define	QL_KMEM_FREE(ptr)	kfree((ptr))

/* Defines for Passthru */
#define IOCTL_INVALID_STATUS			0xffff
#define IOCTL_PASSTHRU_TOV			60

/*
 * extern from ql4_xioctl.c
 */
extern __user void *
Q64BIT_TO_PTR(uint64_t, uint16_t);

extern void *
ql4_kzmalloc(int, gfp_t);

extern char *
IOCTL_TBL_STR(int, int);

extern int
ql4im_alloc_ioctl_mem(ql4im_scsi_qla_host_t *);

extern void
ql4im_free_ioctl_mem(ql4im_scsi_qla_host_t *);

extern int
ql4im_get_ioctl_scrap_mem(ql4im_scsi_qla_host_t *, void **, uint32_t);

extern void
ql4im_free_ioctl_scrap_mem(ql4im_scsi_qla_host_t *);

/*
 * from ql4_inioct.c
 */
extern ioctl_tbl_row_t IOCTL_SCMD_IGET_DATA_TBL[];
extern ioctl_tbl_row_t IOCTL_SCMD_ISET_DATA_TBL[];

extern int
qla4intioctl_logout_iscsi(ql4im_scsi_qla_host_t *, EXT_IOCTL_ISCSI *);

extern int
qla4intioctl_copy_fw_flash(ql4im_scsi_qla_host_t *, EXT_IOCTL_ISCSI *);

extern int
qla4intioctl_iocb_passthru(ql4im_scsi_qla_host_t *, EXT_IOCTL_ISCSI *);

extern int
qla4intioctl_ping(ql4im_scsi_qla_host_t *, EXT_IOCTL_ISCSI *);

extern int
qla4intioctl_get_data(ql4im_scsi_qla_host_t *, EXT_IOCTL_ISCSI *);

extern int
qla4intioctl_set_data(ql4im_scsi_qla_host_t *, EXT_IOCTL_ISCSI *);

extern int
qla4intioctl_hba_reset(ql4im_scsi_qla_host_t *, EXT_IOCTL_ISCSI *);

extern  int
qla4intioctl_restore_factory_defaults(ql4im_scsi_qla_host_t *ql4im_ha, EXT_IOCTL_ISCSI *ioctl);

extern uint8_t
ql4im_resize_ioctl_dma_buf(ql4im_scsi_qla_host_t *ql4im_ha, uint32_t size);

#endif
